"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = depsEntryExports;
exports.stage = void 0;

var _fsExtra = require("fs-extra");

var _type = require("@spark-build/web-utils/lib/type");

var _util = require("../../util");

const stage = -8;
exports.stage = stage;

async function depsEntryExports(api) {
  api.registerMethod({
    name: 'addDepsEntryExports'
  });
  api.onGenerateFiles(async () => {
    const exports = await api.applyPlugins({
      key: 'addDepsEntryExports'
    });

    if (!exports.length) {
      return undefined;
    }

    const exportsToString = exports.map(text => (0, _type.isStr)(text) ? text : (0, _util.spliceExportFrom)(text.specifier || '*', text.source)).join('\n');
    return (0, _fsExtra.outputFile)(api.resolveTmpPath('index.ts'), exportsToString);
  });
}