"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = userGlobalRender;

var fs = _interopRequireWildcard(require("fs-extra"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const resolveFilePathByExts = (exts, resolvePath) => {
  for (let i = 0; i < exts.length; i += 1) {
    const filePath = resolvePath(exts[i]);

    if (fs.existsSync(filePath)) {
      return filePath;
    }
  }

  return '';
};

async function userGlobalRender(api) {
  const appStyleFilePath = resolveFilePathByExts(['css', 'less', 'scss'], ext => api.resolveSrcPath(`app.${ext}`));

  if (appStyleFilePath) {
    const appStyleFilePathSplit = appStyleFilePath.replace(/\\/g, '/').split('/');
    api.addImportToAppEntryFile({
      stage: -10,
      fn: () => `import '@/${appStyleFilePathSplit[appStyleFilePathSplit.length - 1]}';`
    });
  }

  const appFilePath = resolveFilePathByExts(['tsx', 'jsx', 'ts', 'js'], ext => api.resolveSrcPath(`app.${ext}`));

  if (appFilePath) {
    var _await$fs$readFile;

    const appTsxFileContent = (_await$fs$readFile = await fs.readFile(appFilePath)) === null || _await$fs$readFile === void 0 ? void 0 : _await$fs$readFile.toString();

    if (/^export\s(function|const)\srootContainer/gm.test(appTsxFileContent)) {
      api.addImportToAppEntryFile(() => ({
        specifier: '{ rootContainer }',
        source: '@/app'
      }));
      api.addContainerRenderToAppEntryFile({
        stage: 9,
        fn: () => `
function renderRootContainer(children?: React.ReactElement) {
  return rootContainer(children)
}`
      });
    }
  }
}