"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getServicePaths;

var _path = require("path");

var _fsExtra = require("fs-extra");

function isDirectoryAndExist(path) {
  return (0, _fsExtra.existsSync)(path) && (0, _fsExtra.statSync)(path).isDirectory();
}

function getServicePaths({
  cwd,
  env
}) {
  let absSrcPath = cwd;

  if (isDirectoryAndExist((0, _path.join)(cwd, 'src'))) {
    absSrcPath = (0, _path.join)(cwd, 'src');
  }

  const tmpDir = ['.vite-plugin-react-auto-config', env !== 'development' && env].filter(Boolean).join('-');
  return {
    cwd,
    absNodeModulesPath: (0, _path.join)(cwd, 'node_modules'),
    absSrcPath: (0, _path.join)(cwd, 'src'),
    absTmpPath: (0, _path.join)(absSrcPath, tmpDir)
  };
}